.\" Copyright (c) 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)whereis.1	8.2 (Berkeley) 12/30/93
.\"
.\" $FreeBSD: src/usr.bin/whereis/whereis.1,v 1.2.2.2 1999/09/05 11:33:25 peter Exp $
.\"
.Dd June 15, 1996
.Dt WHEREIS 1
.Os FreeBSD
.Sh NAME
.Nm whereis
.Nd locate programs
.Sh SYNOPSIS
.Nm whereis
.Op Fl bms
.Op Fl u
.Op Fl BMS dir ... Fl f
.Ar program ...
.Sh DESCRIPTION
The
.Nm whereis
utility checks the standard binary, manual page, and source
directories for the specified programs, printing out the paths of any
it finds.  The supplied names are first stripped of leading path name
components, any single trailing extension of the form
.Ql .ext ,
and the leading
.Ql s.
or trailing
.Ql ,v
from a source code control system.
.Pp
The default path searched is the string returned by the
.Xr sysctl 8
utility for the
.Dq user.cs_path
string, with
.Pa /usr/libexec
and the current user's
.Ev $PATH
appended.  Manual pages are searched by default along the
.Ev $MANPATH .
Program sources are located in a list of known standard places,
including all the subdirectories of
.Pa /usr/src
and
.Pa /usr/ports .
.Pp
The following options are available:
.Bl -tag -width indent
.It Fl B
Specify directories to search for binaries.  Requires the
.Fl f
option.
.It Fl M
Specify directories to search for manual pages.  Requires the
.Fl f
option.
.It Fl S
Specify directories to search for program sources.  Requires the
.Fl f
option.
.It Fl b
Search for binaries.
.It Fl f
Delimits the list of directories after the
.Fl B ,
.Fl M ,
or
.Fl S
options, and indicates the beginning of the
.Ar name
list.
.It Fl m
Search for manual pages.
.It Fl s
Search for source directories.
.It Fl u
Search for
.Dq unusual
entries.  A file is said to be unusual if it does not have one entry
of each requested type.
.El
.Sh EXAMPLE
The following finds all utilities under
.Pa /usr/bin
that do not have documentation:
.Dl whereis -m -u /usr/bin/*
.Sh SEE ALSO
.Xr find 1 ,
.Xr locate 1 ,
.Xr which 1 ,
.Xr man 1 ,
.Xr sysctl 8
.Sh BUGS
The search for sources is implemented as a quick search as the
first-level subdirectory of each element of the list of source
directories first.  If this didn't succeed, the utility
.Xr locate 1
is requested to do the search in deeper nested subdirectories.  This
might take some time, and will only succeed if the locate database is
up-to-date.
.Sh HISTORY
The
.Nm whereis
command appeared in
.Bx 3.0 .
This version re-implements the historical
functionality that was lost in
.Bx 4.4 .
